bl_info = {
    "name": "AnimCopy",
    "description": "Copies the animation keyframes, just the timing, or just the ease from one object"\
    " to another. Previously (Copy Timing & Ease)",
    "author": "Blastframe",
    "version": (1, 5, 11),
    "blender": (2, 80, 0),
    "location": "Context (Right-Click) Menu",
    "doc_url": "https://blastframe.com/docs/animcopy/",
    "tracker_url": "https://blastframe.com/contact/",
    "category": "Animation",
}

_need_reload = "copy_paste_fcurves" in locals()

if _need_reload:
    import importlib
    utils = importlib.reload(utils)
    check_updates = importlib.reload(check_updates)
    preferences = importlib.reload(preferences)
    copy_paste_fcurves = importlib.reload(copy_paste_fcurves)
    copy_to_selected = importlib.reload(copy_to_selected)
    menu = importlib.reload(menu)

from . import preferences

from .operators import (
    copy_paste_fcurves,
    copy_to_selected
)

from .ui import (
    menu
)

from .utils import (
    check_updates,
    utils
)

modules = [preferences, check_updates, copy_paste_fcurves, copy_to_selected, menu]

def register():
    from .icons.custom_icons import register_custom_icons
    register_custom_icons()
    for mod in modules:
        mod.register()

def unregister():
    from .icons.custom_icons import unregister_custom_icons
    unregister_custom_icons()

    for mod in reversed(modules):
        mod.unregister()
