import bpy

def refresh():
    # Updates all animation related UI
    for area in bpy.context.screen.areas:
        if area.type in {'VIEW_3D', 'DOPESHEET_EDITOR', 'GRAPH_EDITOR', 'NLA_EDITOR', 'OUTLINER', 'PROPERTIES'}:
            for region in area.regions:
                if (area.type == 'VIEW_3D' and region.type == 'UI') or \
                   (area.type != 'VIEW_3D' and region.type in {'WINDOW', 'CHANNELS'}):
                    region.tag_redraw()

def max_diff(a):
    maximum = max(a)
    minimum = min(a)
    return maximum-minimum

def get_prefs():
    # Attempt to determine the add-on name dynamically from available addons
    addon_name = 'delete_static_channels'  # Replace with the unique part of your add-on's name
    addons = bpy.context.preferences.addons
    
    # Loop through all add-ons to find an exact match with the last part of each key
    for key in addons.keys():
        # Split the key by '.' and check the last element
        if key.split('.')[-1].replace(' ', '_').lower() == addon_name.lower():
            return addons[key].preferences  # Return preferences if exact match is found
    
    return None  # Return None if no exact match is found