import bpy
from bpy.types import Operator
from ..utils.utils import get_prefs

class GRAPHKIT_OT_refresh(Operator):
    bl_idname = "wm.refresh_graphkit"
    bl_label = "Refresh GraphKit"
    bl_description = "Refreshes GraphKit icons"
    bl_options = {"REGISTER"}

    def execute(self, context):
        from ..icons.custom_icons import register_custom_icons,unregister_custom_icons
        unregister_custom_icons()
        register_custom_icons()
        if get_prefs().debug_mode:
            print("*** REFRESH GRAPHKIT ***")
        for area in context.screen.areas:
            if area.type == 'GRAPH_EDITOR':
                for region in area.regions:
                    if region.type == "UI":
                        region.tag_redraw()
        return {"FINISHED"}

classes = (GRAPHKIT_OT_refresh,)

def register():
    from bpy.utils import register_class
    for cls in classes:
        register_class(cls)

def unregister():
    from bpy.utils import unregister_class
    for cls in reversed(classes):
        unregister_class(cls)