import math

eases = ["linear",
        "easeInSine",
        "easeInQuad",
        "easeInCubic",
        "easeInQuart",
        "easeInQuint",
        "easeInCirc",
        "easeInExpo",
        "easeOutSine",
        "easeOutQuad",
        "easeOutCubic",
        "easeOutQuart",
        "easeOutQuint",
        "easeOutCirc",
        "easeOutExpo",
        "easeInOutSine",
        "easeInOutQuad",
        "easeInOutCubic",
        "easeInOutQuart",
        "easeInOutQuint",
        "easeInOutCirc",
        "easeInOutExpo",
        "easeInElastic",
        "easeOutElastic",
        "easeInOutElastic",
        "easeInBack",
        "easeOutBack",
        "easeInOutBack",
        "easeInBounce",
        "easeOutBounce",
        "easeInOutBounce"
]

def get_ease_amt(ease_name,amt):
    if ease_name in eases:
        ease_func = eval(ease_name)
        return ease_func(amt)
    else:
        
        return linear(amt)

def linear(n):
    return n

def easeInSine(n):
    return -1 * math.cos(n * math.pi / 2) + 1

def easeOutSine(n):
    return math.sin(n * math.pi / 2)

def easeInOutSine(n):
    return -0.5 * (math.cos(math.pi * n) - 1)

def easeInQuad(n):
    return n**2

def easeOutQuad(n):
    return -n * (n-2)

def easeInOutQuad(n):
    if n < 0.5:
        return 2 * n**2
    else:
        n = n * 2 - 1
        return -0.5 * (n*(n-2) - 1)

def easeInCubic(n):
    return n**3

def easeOutCubic(n):
    n = n - 1
    return n**3 + 1

def easeInOutCubic(n):
    n = 2 * n
    if n < 1:
        return 0.5 * n**3
    else:
        n = n - 2
        return 0.5 * (n**3 + 2)

def easeInQuart(n):
    return n**4

def easeOutQuart(n):
    n = n - 1
    return -(n**4 - 1)

def easeInOutQuart(n):
    n = 2 * n
    if n < 1:
        return 0.5 * n**4
    else:
        n = n - 2
        return -0.5 * (n**4 - 2)

def easeInQuint(n):
    return n**5

def easeOutQuint(n):
    n = n - 1
    return n**5 + 1

def easeInOutQuint(n):
    n = 2 * n
    if n < 1:
        return 0.5 * n**5
    else:
        n = n - 2
        return 0.5 * (n**5 + 2)

def easeInExpo(n):
    if n == 0:
        return 0
    else:
        return 2**(10 * (n - 1))

def easeOutExpo(n):
    if n == 1:
        return 1
    else:
        return -(2 ** (-10 * n)) + 1

def easeInOutExpo(n):
    if n == 0:
        return 0
    elif n == 1:
        return 1
    else:
        n = n * 2
        if n < 1:
            return 0.5 * 2**(10 * (n - 1))
        else:
            n -= 1
            # 0.5 * (-() + 2)
            return 0.5 * (-1 * (2 ** (-10 * n)) + 2)

def easeInCirc(n):
    d = (1 - n * n)
    if d <= 0:
        return n
    return -1 * (math.sqrt(d) - 1)

def easeOutCirc(n):
    d = n-1
    d = 1 - (d * d)
    if d <= 0:
        return n
    #n -= 1
    return math.sqrt(d)

def easeInOutCirc(n):
    n = n * 2
    if n < 1:
        return -0.5 * (math.sqrt(1 - n**2) - 1)
    else:
        n = n - 2
        return 0.5 * (math.sqrt(1 - n**2) + 1)


def easeInElastic(n, amplitude=1, period=0.3):
    return 1 - easeOutElastic(1-n, amplitude=amplitude, period=period)

def easeOutElastic(n, amplitude=1, period=0.3):
    if amplitude < 1:
        amplitude = 1
        s = period / 4
    else:
        s = period / (2 * math.pi) * math.asin(1 / amplitude)

    return amplitude * 2**(-10*n) * math.sin((n-s)*(2*math.pi / period)) + 1


def easeInOutElastic(n, amplitude=1, period=0.5):
    n *= 2
    if n < 1:
        return easeInElastic(n, amplitude=amplitude, period=period) / 2
    else:
        return easeOutElastic(n-1, amplitude=amplitude, period=period) / 2 + 0.5


def easeInBack(n, s=1.70158):
    return n * n * ((s + 1) * n - s)

def easeOutBack(n, s=1.70158):
    n = n - 1
    return n * n * ((s + 1) * n + s) + 1

def easeInOutBack(n, s=1.70158):
    n = n * 2
    if n < 1:
        s *= 1.525
        return 0.5 * (n * n * ((s + 1) * n - s))
    else:
        n -= 2
        s *= 1.525
        return 0.5 * (n * n * ((s + 1) * n + s) + 2)

def easeInBounce(n):
    return 1 - easeOutBounce(1 - n)

def easeOutBounce(n):
    if n < (1/2.75):
        return 7.5625 * n * n
    elif n < (2/2.75):
        n -= (1.5/2.75)
        return 7.5625 * n * n + 0.75
    elif n < (2.5/2.75):
        n -= (2.25/2.75)
        return 7.5625 * n * n + 0.9375
    else:
        n -= (2.65/2.75)
        return 7.5625 * n * n + 0.984375

def easeInOutBounce(n):
    if n < 0.5:
        return easeInBounce(n * 2) * 0.5
    else:
        return easeOutBounce(n * 2 - 1) * 0.5 + 0.5