bl_info = {
    "name": "Keys",
    "description": "Edit multiple keys simultaneously from the user interface.",
    "author": "Blastframe",
    "version": (1, 1, 11),
    "blender": (2, 80, 0),
    "location": "Graph Editor > Sidebar",
    "doc_url": "https://blastframe.com/docs/keys/",
    "tracker_url": "https://blastframe.com/contact/",
    "category": "Animation",
}

_need_reload = "keys" in locals()

from .utils import (
    utils,
    check_updates,
)

from . import preferences

from .operators import (
    keys
)

if _need_reload:
    import importlib
    utils = importlib.reload(utils)
    check_updates = importlib.reload(check_updates)
    preferences = importlib.reload(preferences)
    keys = importlib.reload(keys)

import bpy

def register():
    from .icons.custom_icons import register_custom_icons
    register_custom_icons()
    preferences.register()
    check_updates.register()
    keys.register()

def unregister():
    from .icons.custom_icons import unregister_custom_icons
    unregister_custom_icons()
    keys.unregister()
    check_updates.unregister()
    preferences.unregister()
